{% extends 'base.html' %}
{% load static %}
{% load cartCount %}
{% load rentalCartCount %}

{% block title %}
My Rental Cart | Book-ed
{% endblock %}

{% block content %}
<div class="container-fluid">
    <div class="row">
        <div class="col-xs-12">
            <div class='parallax'>
                <h2>My Rental Cart</h2>
                {% if user|rentalCartNum %}
                <div class='table-responsive'>

                    <table class='table table-striped'>
                        <thead>
                            <tr>
                                <th>Title</th>
                                <!-- <th>Security (Refundable)</th> -->
                                <!-- <th>Rent (Non-refundable)</th> -->
                                <th>Total Payable Amount</th>
                                <th>Remove from Cart</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for i,amount in items %}

                            <tr>
                                <td>
                                    <a href='/books/{{ i.book.pk}}/'>{{ i.book.title }}</a>
                                </td>
                                <td>{{ i.book.refundableSecurity }} (refundable) + <br/>
                                    {{ i.book.rent }} (non-refundable rent) = <br/>
                                    {{ amount }}</td>
                                <td>
                                    <a href='/books/{{i.pk}}/removeFromRentalCart/'>Remove</a>
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                </div>

                <div class='col-xs-12'>
                    Total: {{ totalAmount }}
                    <button type="button" class="btn btn-lg btn-info"  data-toggle="modal" data-target="#verificationModal">Checkout</button>
                </div>
                {% else %}
                No Items Here!
                {% endif %}
            </div>
        </div>
    </div>
    <!-- <div class="row"> -->
    <!--     <div class="col-xs-12"> -->
    <!--         <div class="absolute"> -->
    <!--             <div class="parallaxWhite"> -->
    <!--                 <1!-- Content Here --1> -->
    <!--             </div> -->
    <!--         </div> -->
    <!--     </div> -->
    <!-- </div> -->
</div>

<!-- Container element -->
<!-- <div class="parallax"></div> -->

<!-- Verification Modal -->
<div id="verificationModal" class="modal fade" role="dialog">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">Checkout</h4>
            </div>
            <div class="modal-body">
                <p>We need to send an OTP to your registered mobile number and email id.</p>
                <form action="/books/cart/verified/" method="get" accept-charset="utf-8">
                    <p>
                    Shipping Address: 
                    <textarea class="form-control" name="address" id="address" rows="2" cols="40"></textarea>
                    <br/>
                    Amount: {{ totalAmount }}
                    <br/>
                    Payment Option: 
                    <select class="form-control" name="paymentOption" id="paymentOption" onchange="" size="1">
                        <option value="COD">Cash On Delivery</option>
                        <option value="Online">Online Payment (Netbanking, Debit Cards etc)</option>
                    </select>

                    <!-- Rent from Date -->
                    <!-- TODO: Show calendar -->
                    <!-- <input type="text" name="startDate" id="startDate" class='form-control' placeholder='dd-mm-yy' value=""> -->

                    Number of Days
                    <input class="form-control" type="number" name="duration" id="duration" value="">
                    </p>
                    <div id="otpError" style="background:yellow;display:none;">
                        <h3>There was an error trying to send the otp. Please try again later!</h3>
                    </div>
                    <div id="incorrectOtp" style="background:red;display:none;">
                        <h3>The OTP you entered was incorrect or already used by you.</h3>
                    </div>
                    <div id="otpVerify" style="display:none;">
                        <h3>An OTP has been sent to your mobile number and email id.</h3>
                        Enter OTP:<input class="form-control" type="text" name="otp" id="otp" value=""> 
                        <button id='otpVerifyBtn' type="button" class="btn btn-info" onclick='verifyOtp();'>Verify and Confirm Order</button>
                    </div>
                    <p>
                    <button id='sendOtpBtn' type="button" class="btn btn-info" onclick='sendOtp();'>Send OTP</button>
                    </p>

                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>

    </div>
</div>
<!-- Verification Modal -->

<div id="hiddenForm" class="name">
</div>

<script type="text/javascript" charset="utf-8">
function sendOtp() {
    var xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            resp = JSON.parse(this.responseText);
            console.log(resp);
            if(resp['status'] = 'sent')
            {
                document.getElementById("otpVerify").style.display = 'block';
            }
            else
            {
                document.getElementById("otpVerify").style.display = 'none';
                document.getElementById("otpError").style.display = 'block';
            }
        }
    };

    var url = '/sendOtp/';
    xhttp.open("GET", url, true);
    xhttp.send();
}

function verifyOtp() {
    var xhttp = new XMLHttpRequest();
    document.getElementById('otpVerifyBtn').value = 'Verifying';
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            resp = JSON.parse(this.responseText);
            if(resp['status'] == 'Verified')
            {
                document.getElementById('otpVerifyBtn').value = 'Please Wait';
                document.getElementById("incorrectOtp").style.display = 'none';
                //redirect to success page
                var paymentOption =  document.getElementById('paymentOption').value;
                if(paymentOption == 'COD')
                {
                    //Order complete: Nothing else to do
                    //Post the id that came in response to success page
                    $('#hiddenForm').html('<form action="/books/orderComplete/" name="formSuccess" method="get" style="display:none;"><input type="text" name="shipmentPk" value="' + resp['id'] + '" /></form>');
                    document.forms['formSuccess'].submit();
                }
                else
                {
                    //Show razorpay payment gateway; collect payment and post the details to onlinePayment page
                    var totalAmount = (resp['amount']*100).toString();
                    var options = {
                        "key": "rzp_test_7Kw2wESOi945RD",
                        "amount": totalAmount, // 100 paise = INR 1
                        "name": "Book-ed",
                        "description": "Book-ed Online Payment",
                        //"image": "/your_logo.png",
                        "handler": function (response){
                            //Send values to onlinePayment endpoint
                            $('#hiddenForm').html('<form action="/books/cart/onlinePayment/" name="formSuccess" method="post" style="display:none;"><input type="text" name="paymentId" value="' + response.razorpay_payment_id + '" /><input type="text" name="shipmentId" value="' + resp['id'] + '" /></form>');
                            document.forms['formSuccess'].submit();
                        },
                        "prefill": {
                            "name": "",
                            "email": ""
                        },
                        "notes": {
                            "address": ""
                        },
                        "theme": {
                            "color": "#F37254"
                        }
                    };

                    var rzp1 = new Razorpay(options);
                    rzp1.open();
                }
            }
            else
            {
                document.getElementById("incorrectOtp").style.display = 'block';
                document.getElementById('otpVerifyBtn').value = 'Verify';
            }
            document.getElementById("sendOtpBtn").innerHTML = 'Resend OTP';
        }
    };

    var url = '/verifyOtp/';
    var params = '';
    var enteredOtp = document.getElementById('otp').value;
    var address =  document.getElementById('address').value;
    var amount =  "{{ totalAmount }}";
    var paymentOption =  document.getElementById('paymentOption').value;
    var duration =  document.getElementById('duration').value;
    //var startDate =  document.getElementById('startDate').value;

    params += 'otp='+enteredOtp + '&paymentOption=' + paymentOption + '&address=' + address + '&duration=' + duration;

    xhttp.open("POST", url, true);
    xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xhttp.send(params);
}
</script>

<script src="https://checkout.razorpay.com/v1/checkout.js"></script>
{% endblock %}
